/*
 =================== DO NOT EDIT THIS FILE ====================
 Generated by Modello 1.6 on 2013-07-12 14:15:16,
 any modifications will be overwritten.
 ==============================================================
 */

package org.sonatype.security.ldap.realms.persist.model;

/**
 * The user and group mapping configuration mapping.
 * 
 * @version $Revision$ $Date$
 */
@SuppressWarnings( "all" )
public class CUserAndGroupAuthConfiguration
    implements java.io.Serializable
{

      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Email Address Attribute.  The attribute that stores the
     * users email address.
     */
    private String emailAddressAttribute;

    /**
     * Use LDAP groups as roles.  True if LDAP groups should be
     * used as roles.
     */
    private boolean ldapGroupsAsRoles = false;

    /**
     * Group Base DN.  The base DN that defines Groups.
     */
    private String groupBaseDn;

    /**
     * Group Id Attribute. The ID attribute for the Group. 
     */
    private String groupIdAttribute;

    /**
     * Group Member Attribute,  An attribute that defines the a
     * user is a member of the group.
     */
    private String groupMemberAttribute;

    /**
     * Group Member Format. The format that the user info is stored
     * in the groupMappingsAttribute.  Such as ${username}, or
     * uid=${username},ou=people,o=yourBiz.  ${username} will be
     * replaced with the username.
     */
    private String groupMemberFormat;

    /**
     * Group Object Class. The Object class used for groups.
     */
    private String groupObjectClass;

    /**
     * User Password Attribute.  The attribute that stores the
     * users password.
     */
    private String userPasswordAttribute;

    /**
     * TODO: Remove Field (no longer used) <BR/>Preferred Password
     * Encoding. The encoding scheme used for user passwords:
     * plain, crypt, ect.
     */
    private String preferredPasswordEncoding;

    /**
     * User Id Attribute.  THe attribute of the userId field.
     */
    private String userIdAttribute;

    /**
     * User Object Class.  The object class used for users.
     */
    private String userObjectClass;

    /**
     * User Base DN. The base DN for the users.
     */
    private String userBaseDn;

    /**
     * User Real Name Attribute.  The attribute that defines the
     * users real name.
     */
    private String userRealNameAttribute;

    /**
     * Users are Stored in a subtree of the userBaseDn.
     */
    private boolean userSubtree = false;

    /**
     * Groups are Stored in a subtree of the groupBaseDn.
     */
    private boolean groupSubtree = false;

    /**
     * Groups are generally one of two types in LDAP systems -
     * static or dynamic. A static group maintains its own
     * membership list. A dynamic group records its membership on a
     * user entry. If dynamic groups this should be set to the
     * attribute used to store the group string in the user object.
     */
    private String userMemberOfAttribute;

    /**
     * Filter to limit user search to user with specific attribute.
     */
    private String ldapFilter;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Get email Address Attribute.  The attribute that stores the
     * users email address.
     * 
     * @return String
     */
    public String getEmailAddressAttribute()
    {
        return this.emailAddressAttribute;
    } //-- String getEmailAddressAttribute()

    /**
     * Get group Base DN.  The base DN that defines Groups.
     * 
     * @return String
     */
    public String getGroupBaseDn()
    {
        return this.groupBaseDn;
    } //-- String getGroupBaseDn()

    /**
     * Get group Id Attribute. The ID attribute for the Group.
     * 
     * @return String
     */
    public String getGroupIdAttribute()
    {
        return this.groupIdAttribute;
    } //-- String getGroupIdAttribute()

    /**
     * Get group Member Attribute,  An attribute that defines the a
     * user is a member of the group.
     * 
     * @return String
     */
    public String getGroupMemberAttribute()
    {
        return this.groupMemberAttribute;
    } //-- String getGroupMemberAttribute()

    /**
     * Get group Member Format. The format that the user info is
     * stored in the groupMappingsAttribute.  Such as ${username},
     * or uid=${username},ou=people,o=yourBiz.  ${username} will be
     * replaced with the username.
     * 
     * @return String
     */
    public String getGroupMemberFormat()
    {
        return this.groupMemberFormat;
    } //-- String getGroupMemberFormat()

    /**
     * Get group Object Class. The Object class used for groups.
     * 
     * @return String
     */
    public String getGroupObjectClass()
    {
        return this.groupObjectClass;
    } //-- String getGroupObjectClass()

    /**
     * Get filter to limit user search to user with specific
     * attribute.
     * 
     * @return String
     */
    public String getLdapFilter()
    {
        return this.ldapFilter;
    } //-- String getLdapFilter()

    /**
     * Get tODO: Remove Field (no longer used) <BR/>Preferred
     * Password Encoding. The encoding scheme used for user
     * passwords: plain, crypt, ect.
     * 
     * @return String
     */
    public String getPreferredPasswordEncoding()
    {
        return this.preferredPasswordEncoding;
    } //-- String getPreferredPasswordEncoding()

    /**
     * Get user Base DN. The base DN for the users.
     * 
     * @return String
     */
    public String getUserBaseDn()
    {
        return this.userBaseDn;
    } //-- String getUserBaseDn()

    /**
     * Get user Id Attribute.  THe attribute of the userId field.
     * 
     * @return String
     */
    public String getUserIdAttribute()
    {
        return this.userIdAttribute;
    } //-- String getUserIdAttribute()

    /**
     * Get groups are generally one of two types in LDAP systems -
     * static or dynamic. A static group maintains its own
     * membership list. A dynamic group records its membership on a
     * user entry. If dynamic groups this should be set to the
     * attribute used to store the group string in the user object.
     * 
     * @return String
     */
    public String getUserMemberOfAttribute()
    {
        return this.userMemberOfAttribute;
    } //-- String getUserMemberOfAttribute()

    /**
     * Get user Object Class.  The object class used for users.
     * 
     * @return String
     */
    public String getUserObjectClass()
    {
        return this.userObjectClass;
    } //-- String getUserObjectClass()

    /**
     * Get user Password Attribute.  The attribute that stores the
     * users password.
     * 
     * @return String
     */
    public String getUserPasswordAttribute()
    {
        return this.userPasswordAttribute;
    } //-- String getUserPasswordAttribute()

    /**
     * Get user Real Name Attribute.  The attribute that defines
     * the users real name.
     * 
     * @return String
     */
    public String getUserRealNameAttribute()
    {
        return this.userRealNameAttribute;
    } //-- String getUserRealNameAttribute()

    /**
     * Get groups are Stored in a subtree of the groupBaseDn.
     * 
     * @return boolean
     */
    public boolean isGroupSubtree()
    {
        return this.groupSubtree;
    } //-- boolean isGroupSubtree()

    /**
     * Get use LDAP groups as roles.  True if LDAP groups should be
     * used as roles.
     * 
     * @return boolean
     */
    public boolean isLdapGroupsAsRoles()
    {
        return this.ldapGroupsAsRoles;
    } //-- boolean isLdapGroupsAsRoles()

    /**
     * Get users are Stored in a subtree of the userBaseDn.
     * 
     * @return boolean
     */
    public boolean isUserSubtree()
    {
        return this.userSubtree;
    } //-- boolean isUserSubtree()

    /**
     * Set email Address Attribute.  The attribute that stores the
     * users email address.
     * 
     * @param emailAddressAttribute
     */
    public void setEmailAddressAttribute( String emailAddressAttribute )
    {
        this.emailAddressAttribute = emailAddressAttribute;
    } //-- void setEmailAddressAttribute( String )

    /**
     * Set group Base DN.  The base DN that defines Groups.
     * 
     * @param groupBaseDn
     */
    public void setGroupBaseDn( String groupBaseDn )
    {
        this.groupBaseDn = groupBaseDn;
    } //-- void setGroupBaseDn( String )

    /**
     * Set group Id Attribute. The ID attribute for the Group.
     * 
     * @param groupIdAttribute
     */
    public void setGroupIdAttribute( String groupIdAttribute )
    {
        this.groupIdAttribute = groupIdAttribute;
    } //-- void setGroupIdAttribute( String )

    /**
     * Set group Member Attribute,  An attribute that defines the a
     * user is a member of the group.
     * 
     * @param groupMemberAttribute
     */
    public void setGroupMemberAttribute( String groupMemberAttribute )
    {
        this.groupMemberAttribute = groupMemberAttribute;
    } //-- void setGroupMemberAttribute( String )

    /**
     * Set group Member Format. The format that the user info is
     * stored in the groupMappingsAttribute.  Such as ${username},
     * or uid=${username},ou=people,o=yourBiz.  ${username} will be
     * replaced with the username.
     * 
     * @param groupMemberFormat
     */
    public void setGroupMemberFormat( String groupMemberFormat )
    {
        this.groupMemberFormat = groupMemberFormat;
    } //-- void setGroupMemberFormat( String )

    /**
     * Set group Object Class. The Object class used for groups.
     * 
     * @param groupObjectClass
     */
    public void setGroupObjectClass( String groupObjectClass )
    {
        this.groupObjectClass = groupObjectClass;
    } //-- void setGroupObjectClass( String )

    /**
     * Set groups are Stored in a subtree of the groupBaseDn.
     * 
     * @param groupSubtree
     */
    public void setGroupSubtree( boolean groupSubtree )
    {
        this.groupSubtree = groupSubtree;
    } //-- void setGroupSubtree( boolean )

    /**
     * Set filter to limit user search to user with specific
     * attribute.
     * 
     * @param ldapFilter
     */
    public void setLdapFilter( String ldapFilter )
    {
        this.ldapFilter = ldapFilter;
    } //-- void setLdapFilter( String )

    /**
     * Set use LDAP groups as roles.  True if LDAP groups should be
     * used as roles.
     * 
     * @param ldapGroupsAsRoles
     */
    public void setLdapGroupsAsRoles( boolean ldapGroupsAsRoles )
    {
        this.ldapGroupsAsRoles = ldapGroupsAsRoles;
    } //-- void setLdapGroupsAsRoles( boolean )

    /**
     * Set tODO: Remove Field (no longer used) <BR/>Preferred
     * Password Encoding. The encoding scheme used for user
     * passwords: plain, crypt, ect.
     * 
     * @param preferredPasswordEncoding
     */
    public void setPreferredPasswordEncoding( String preferredPasswordEncoding )
    {
        this.preferredPasswordEncoding = preferredPasswordEncoding;
    } //-- void setPreferredPasswordEncoding( String )

    /**
     * Set user Base DN. The base DN for the users.
     * 
     * @param userBaseDn
     */
    public void setUserBaseDn( String userBaseDn )
    {
        this.userBaseDn = userBaseDn;
    } //-- void setUserBaseDn( String )

    /**
     * Set user Id Attribute.  THe attribute of the userId field.
     * 
     * @param userIdAttribute
     */
    public void setUserIdAttribute( String userIdAttribute )
    {
        this.userIdAttribute = userIdAttribute;
    } //-- void setUserIdAttribute( String )

    /**
     * Set groups are generally one of two types in LDAP systems -
     * static or dynamic. A static group maintains its own
     * membership list. A dynamic group records its membership on a
     * user entry. If dynamic groups this should be set to the
     * attribute used to store the group string in the user object.
     * 
     * @param userMemberOfAttribute
     */
    public void setUserMemberOfAttribute( String userMemberOfAttribute )
    {
        this.userMemberOfAttribute = userMemberOfAttribute;
    } //-- void setUserMemberOfAttribute( String )

    /**
     * Set user Object Class.  The object class used for users.
     * 
     * @param userObjectClass
     */
    public void setUserObjectClass( String userObjectClass )
    {
        this.userObjectClass = userObjectClass;
    } //-- void setUserObjectClass( String )

    /**
     * Set user Password Attribute.  The attribute that stores the
     * users password.
     * 
     * @param userPasswordAttribute
     */
    public void setUserPasswordAttribute( String userPasswordAttribute )
    {
        this.userPasswordAttribute = userPasswordAttribute;
    } //-- void setUserPasswordAttribute( String )

    /**
     * Set user Real Name Attribute.  The attribute that defines
     * the users real name.
     * 
     * @param userRealNameAttribute
     */
    public void setUserRealNameAttribute( String userRealNameAttribute )
    {
        this.userRealNameAttribute = userRealNameAttribute;
    } //-- void setUserRealNameAttribute( String )

    /**
     * Set users are Stored in a subtree of the userBaseDn.
     * 
     * @param userSubtree
     */
    public void setUserSubtree( boolean userSubtree )
    {
        this.userSubtree = userSubtree;
    } //-- void setUserSubtree( boolean )

}
